/* !
 * jQuery LinkySelect Plugin 1.0 (13.08.2014)
 * Copyright (c) 2014, Vadym Danyliuk < vdlinky@gmail.com >
 * Released under the MIT license
 */

!(function ($) {

  if (!window.jQuery) {
    return console.log('Виникла помилка! Для роботи плагіна LinkySelect потрібна бібліотека jQuery 1.10+');
  }

  $.fn.LinkySelect = function (optuser) {

    this.each(function () {

      // Поточний селектор
      var $select = $(this);

      // Налаштування плагіна
      var options = $.extend({}, {
        selectedValue: true, // Встановити активним поле селектора з вказаним value (якщо true, то вибрати перше поле)
        showFilter: false, // Показати поле фільтра
        hideSelected: true, // Приховати вибраний елемент списку
        animation: 'slide', // Анімація селектора ('slide', 'fade')
        animationSpeed: 200, // Швидкість анімації селектора
        preventSelection: true, // Заборонити виділення тексту
        headerText: 'Виберіть із списку:', // Стандартний заголовок селектора
        emptyText: 'Не знайдено', // Стандартний текст пустого результату фільтрування
        onChange: null, // Зміна активного елемента списку (передається value)
        onFilter: null, // Ввід у поле фільтру (передається value)
      }, optuser);

      // Персоналізація стилів селектора
      options.classes = $.extend({}, {
        lsActivated: '.linky-select__activated',
        lsContainer: '.linky-select__container',
        lsHeader: '.linky-select__header',
        lsHeaderText: '.linky-select__header--text',
        lsDropdown: '.linky-select__dropdown',
        lsDropdownFilter: '.linky-select__dropdown--filter',
        lsBody: '.linky-select__body',
        lsBodyItem: '.linky-select__body--item',
        lsBodyHeader: '.linky-select__body--header',
        lsBodyNofind: '.linky-select__body--nofind',
        lsActive: '.linky-select__active',
        lsSelected: '.linky-select__selected',
        lsHidden: '.linky-select__hidden',
        lsInited: '.linky-select__inited'
      }, options.classes);

      // Додаткові змінні плагіна
      options.listHtml = null;
      options.textFields = [];

      // Шаблон селектора
      var html = '';
      html += '<div class="' + options.classes.lsContainer.slice(1) + '">';
      html += '<div class="' + options.classes.lsHeader.slice(1) + '">';
      // html += '<span class="linky-select__header--image"></span>';
      html += '<span class="' + options.classes.lsHeaderText.slice(1) + '">' + options.headerText + '</span>';
      html += '</div>';
      html += '<div class="' + options.classes.lsDropdown.slice(1) + '">';

      if (options.showFilter) {
        html += '<input type="text" class="' + options.classes.lsDropdownFilter.slice(1) + '" />';
      }

      html += '<div class="' + options.classes.lsBody.slice(1) + '">';

      // html += '<div class="linky-select__body--header" data-type="header">Заголовок</div>';
      // html += '<div class="linky-select__body--item" data-value="0">Поле списку</div>';

      html += '</div>';
      html += '</div>';
      html += '</div>';

      $select.after(html);

      // Контекст поточного селектора
      var $context = $select.next();

      var exec = {

        // Ініціалізація селектора
        init: function (FirstInit) {

          if ($select.children().length === $context.find(options.classes.lsBody).children().length - 1 && $select.children().not(options.classes.lsInited).length === 0 && !FirstInit) return;

          var $options = $select.children().addClass(options.classes.lsInited.slice(1));

          var html = '';
          $options.each(function () {
            html += exec.createLine($(this));
          });

          options.listHtml = html;

          exec.pushList(html);

          // Зберегти список назв полів селектора для швидшої фільтрації
          if (options.showFilter) {
            $options.each(function (index) {
              options.textFields[index] = $(this).text();
            });

            $context.find(options.classes.lsBodyNofind).hide();
          }

          if (!FirstInit) return;

          // Активувати вказане поле селектора при ініціалізації
          if (options.selectedValue) {
            if (typeof options.selectedValue === 'string' && $context.find('div[data-value="' + options.selectedValue + '"]').length) {
              exec.select(options.selectedValue);
            } else if (options.selectedValue === true) {
              exec.select($context.find(options.classes.lsBodyItem).first().data('value'));
            }
          }

          // Додати користувацькі класи селектору
          $context.addClass($select.attr('class'));

          exec.initEvent();
        },

        // Ініціалізація операції вибору поля селектора
        initList: function () {

          // Вибір потрібного поля селектора
          $context.find(options.classes.lsBodyItem).on('click', function () {
            exec.select($(this).data('value'));
          });
        },

        // Розгорнути селектор
        open: function () {

          // Згорнути усі активні селектори
          $(options.classes.lsHeader).filter(options.classes.lsActive.slice(1)).click();

          $context.addClass(options.classes.lsActive.slice(1)).find('> ' + options.classes.lsHeader).addClass(options.classes.lsActive.slice(1));

          // Анімація розгортання селектора
          $context.find(options.classes.lsDropdown).each(function () {
            if (options.animation.toLowerCase() === 'fade') {
              $(this).fadeIn(options.animationSpeed);
            } else if (options.animation.toLowerCase() === 'slide') {
              $(this).slideDown(options.animationSpeed);
            } else {
              $(this).slideDown(options.animationSpeed);
            }
          });

          if (options.showFilter) {
            $context.find(options.classes.lsDropdownFilter).focus();
          }
        },

        // Згорнути селектор
        close: function () {

          $context.removeClass(options.classes.lsActive.slice(1)).find('> ' + options.classes.lsHeader).removeClass(options.classes.lsActive.slice(1));
          $context.find(options.classes.lsBodyItem).removeClass(options.classes.lsSelected.slice(1)).not(options.classes.lsActive).removeAttr('style');

          // Анімація згортання селектора
          $context.find(options.classes.lsDropdown).each(function () {
            if (options.animation.toLowerCase() === 'fade') {
              $(this).fadeOut(options.animationSpeed);
            } else if (options.animation.toLowerCase() === 'slide') {
              $(this).slideUp(options.animationSpeed);
            } else {
              $(this).slideUp(options.animationSpeed);
            }
          });

          $context.find(options.classes.lsDropdownFilter).val('');
          $context.find(options.classes.lsBodyNofind).hide();
          $context.find(options.classes.lsBody).scrollTop(0).children().removeClass(options.classes.lsHidden.slice(1));
        },

        // Вибір потрібного поля селектора
        select: function (value, trigged) {

          // Виправлення для покращення алгоритму :)
          if (!trigged) {
            return $select.val(value).change();
          }

          // Знайти потрібне поле селектора по value
          var $item = $context.find(options.classes.lsBodyItem).filter('[data-value="' + value + '"]');

          // Закинути у заголовок селектора поточні дані
          $context.find(options.classes.lsHeaderText).text($item.text()).data('value', value);

          // Виділити потрібне поле селектора
          $context.find(options.classes.lsBodyItem).show().removeClass(options.classes.lsActive.slice(1));
          $item.addClass(options.classes.lsActive.slice(1));

          if (options.hideSelected) {
            $item.hide();
          }
        },

        // Згенерувати поле селектора
        createLine: function ($item, value) {
          var classType = ($item.data('type') && $item.data('type') === 'header' ? (function () {
            // $item.remove();
            return options.classes.lsBodyHeader.slice(1);
          })($item) : options.classes.lsBodyItem.slice(1));
          return '<div class="' + classType + (value && $select.val() === value ? ' ' + options.classes.lsActive.slice(1) : '') + '" data-value="' + $item.val() + '">' + $item.text() + '</div>';
        },

        // Завантажити список полів у селектор
        pushList: function (list) {
          list += '<div class="' + options.classes.lsBodyNofind.slice(1) + '">' + options.emptyText + '</div>';
          $context.find(options.classes.lsBody).html(list);
          exec.initList();
        },

        // Фільтрація даних
        filter: function (value) {

          var $items = $context.find(options.classes.lsBody).children();

          $context.find(options.classes.lsBodyNofind).hide();

          // Обнулити поля селектора, якщо поле фільтру пусте
          if (value === '') {
            $items.removeClass(options.classes.lsHidden.slice(1));
            return;
          }

          // Фільтрування потрібних полів
          var html = '';
          for (var i = 0; i < options.textFields.length; i++) {

            if ($items.eq(i).hasClass(options.classes.lsBodyHeader.slice(1))) {
              $items.eq(i).addClass(options.classes.lsHidden.slice(1));
              continue;
            }

            if (options.textFields[i].search(value) >= 0 && !$items.eq(i).hasClass(options.classes.lsActive.slice(1))) {
              $items.eq(i).removeClass(options.classes.lsHidden.slice(1));
            } else {
              $items.eq(i).addClass(options.classes.lsHidden.slice(1));
            }
          }

          if ($items.not(options.classes.lsActive + ',' + options.classes.lsHidden + ',' + options.classes.lsBodyHeader + ',' + options.classes.lsBodyNofind).length === 0) {
            $context.find(options.classes.lsBodyNofind).show();
          }
        },

        // Ініціалізація зовнішніх подій
        initEvent: function () {

          if ($('body').hasClass(options.classes.lsActivated)) return;

          // Зберегти прапор ініціалізації плагіна
          $('body').addClass(options.classes.lsActivated.slice(1));

          // Закрити при необхідності всі селектори
          $('html').on('click', function () {
            $(options.classes.lsHeader).filter(options.classes.lsActive).click();
          });

          // Переміщення по списку полів селектора
          $('html').on('keydown', function (event) {

            var $container = $(options.classes.lsContainer).filter(options.classes.lsActive);

            if (!$container.length || (event.keyCode !== 38 && event.keyCode !== 40 && event.keyCode !== 13)) return;

            var $body = $container.find(options.classes.lsBody);
            var $items = $body.find(options.classes.lsBodyItem);

            // Якщо не знайдено виділеного поля селектора
            if (!$items.filter(options.classes.lsSelected).length) {

              if (event.keyCode === 40) {
                $items.not(options.classes.lsActive + ',' + options.classes.lsHidden).first().addClass(options.classes.lsSelected.slice(1));
                $body.scrollTop(0);
              } else if (event.keyCode === 38) {
                $items.not(options.classes.lsActive + ',' + options.classes.lsHidden).last().addClass(options.classes.lsSelected.slice(1));
                $body.scrollTop($body[0].scrollHeight);
              }

              return;
            }

            // Вибрати виділене поле селектора
            if (event.keyCode === 13) {
              return $items.filter(options.classes.lsSelected).first().click();
            }

            var bodyHeight = $body.height();
            var itemHeight = $items.height();
            var filterHeight = $body.position().top;
            var selectOffsetTop = 0;

            var $selected = $items.filter(options.classes.lsSelected).removeClass(options.classes.lsSelected.slice(1));
            var filterString = options.classes.lsActive + ',' + options.classes.lsHidden + ',' + options.classes.lsBodyNofind + ',' + options.classes.lsBodyHeader;

            // Опуститися вниз по списку полів селектора
            if (event.keyCode === 40) {
              if ($selected.nextAll().not(filterString).length) {
                selectOffsetTop = $selected.nextAll().not(filterString).first().addClass(options.classes.lsSelected.slice(1)).position().top;

                if (selectOffsetTop - bodyHeight - filterHeight >= 0) {
                  $body.scrollTop(selectOffsetTop - bodyHeight - filterHeight + $body.scrollTop() + itemHeight);
                }
              } else {
                $selected.prevAll().not(filterString).last().addClass(options.classes.lsSelected.slice(1));
                $body.scrollTop(0);
              }
            }

            // Піднятися вверх по списку полів селектора
            if (event.keyCode === 38) {
              if ($selected.prevAll().not(filterString).length) {
                selectOffsetTop = $selected.prevAll().not(filterString).first().addClass(options.classes.lsSelected.slice(1)).position().top;

                if (selectOffsetTop <= 0) {
                  $body.scrollTop(selectOffsetTop + $body.scrollTop() - filterHeight);
                }
              } else {
                $selected.nextAll().not(filterString).last().addClass(options.classes.lsSelected.slice(1));
                $body.scrollTop($body[0].scrollHeight);
              }
            }
          });
        }
      };

      // Згорнути/Розгорнути селектор
      $context.find(options.classes.lsHeader).on('click', function () {

        // Зупинити роботу селектора, якщо реальний селектор неактивний
        if ($(this).parent().prev().prop('disabled')) return;

        if ($(this).hasClass(options.classes.lsActive.slice(1))) {
          exec.close();
        } else {
          exec.open();
        }
      });

      // Фільтрація даних
      $context.find(options.classes.lsDropdownFilter).on('keyup', function (event) {

        if (event.keyCode >= 37 && event.keyCode <= 40 || event.keyCode === 13) return;

        exec.filter($(this).val());

        if (options.onFilter && $.isFunction(options.onFilter)) {
          options.onFilter($(this).val());
        }
      });

      if (options.preventSelection) {

        // Заборона виділення тексту на селекторі
        $context[0].onmousedown = $context[0].onselectstart = function () {
          return false;
        };

        // Дозволити виділяти текст у полі фільтру
        if (options.showFilter) {
          $context.find(options.classes.lsDropdownFilter)[0].onmousedown = $context.find(options.classes.lsDropdownFilter)[0].onselectstart = function () {
            event.stopPropagation();
            return true;
          };
        }
      }

      // Виникнення події change на реальному селекті
      $select.on('change', function () {
        exec.select($(this).val(), true);
        exec.close();

        exec.init();

        if (options.onChange && $.isFunction(options.onChange)) {
          options.onChange($(this).val());
        }
      });

      // Зупинити підняття подій вверх по DOM
      $context.on('click', function (event) {
        event.stopPropagation();
      });

      exec.init(true);

    }).hide();

    return this;
  };

})(window.jQuery);
